window.addEventListener("load",function() {POTO_Localize();} ,false);

function POTO_Localize () {
   var potosidebarLocalizationPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{f15f8c61-2830-4498-9762-2677a6b6e1d5}.");
   var str = Components.classes[ "@mozilla.org/supports-string;1" ].createInstance( Components.interfaces.nsISupportsString );
   str.data = document.getElementById("potosidebar-strings").getString("potosidebar.description");
   potosidebarLocalizationPrefs.setComplexValue("description", Components.interfaces.nsISupportsString, str);
}

function POTO_Left(str, n){
	if (n <= 0)
	    return "";
	else if (n > String(str).length)
	    return str;
	else
	    return String(str).substring(0,n);
}

function POTO_UpdateHidden() {
  var potosidebarvbox = document.getElementById('potosidebar-vbox');
  var sidebar = document.getElementById('sidebar-box');
  
  potosidebarvbox.setAttribute("hidden", sidebar.hidden);
  
  //var sidebartitle = document.getElementById('sidebar-title');
  //alert(sidebartitle.getAttribute('lastopen'));
}

function POTO_RemLastOpen() {
  var mainwindow = document.getElementById('main-window');
  var sidebartitle = document.getElementById('sidebar-title');
  
  mainwindow.setAttribute("lastopen", sidebartitle.getAttribute('value'));
  //mainwindow.setAttribute("persist", "lastopen");
  //alert(mainwindow.getAttribute('lastopen'));
  //alert(mainwindow.getAttribute('persist'));
}

function POTO_ToggleSidebar() {
  var mainwindow = document.getElementById('main-window');
  var sidebar = document.getElementById('sidebar-box');
  //var sidebartitle = document.getElementById('sidebar-title');
  var potosidebarvbox = document.getElementById('potosidebar-vbox');
  var lastopen = mainwindow.getAttribute('lastopen');
  var popup = document.getElementById('viewSidebarMenu');
  var potosidebartoolbar = document.getElementById('potosidebar-toolbar');
  var command;
  
  var pref_iconmode = CommonFunc.getPrefValue(CommonFunc.ICON_MODE, "str", "icons");
  var pref_largeicons = CommonFunc.getPrefValue(CommonFunc.LARGE_ICONS, "bool", false);

  //Apply Preferences
  potosidebartoolbar.setAttribute("mode", pref_iconmode);
  if (pref_largeicons) {
    potosidebartoolbar.setAttribute("iconsize", "large");
  } else {
    potosidebartoolbar.setAttribute("iconsize", "small");
  }

  if (sidebar.hidden == false) {
    //POTO_RemLastOpen();
    toggleSidebar();
    //sidebartitle.setAttribute("lastopen", sidebartitle.getAttribute('value'));
    potosidebarvbox.hidden = true;
  } else {
    for (i = 0; i < popup.childNodes.length; i++) {
      if (lastopen == popup.childNodes[i].label) {
        command = popup.childNodes[i].getAttribute('oncommand');
      }
    }
    /*if (lastopen == "") {
      toggleSidebar('viewBookmarksSidebar');
    } else if (lastopen == "Bookmarks") {
      toggleSidebar("viewBookmarksSidebar");
    } else if (lastopen == "History") {
      toggleSidebar("viewHistorySidebar");
    } else if (lastopen == "Downloads") {
      toggleSidebar("viewDownloadsSidebar");
    }*/
    if (command == null) {
      toggleSidebar("viewDownloadsSidebar");
    } else {
      eval(command);
    }
    potosidebarvbox.hidden = false;
  }
}

function toggleSidebar(aCommandID, forceOpen) {
  var sidebarBox = document.getElementById("sidebar-box");
  if (!aCommandID)
    aCommandID = sidebarBox.getAttribute("sidebarcommand");

  var elt = document.getElementById(aCommandID);
  var sidebar = document.getElementById("sidebar");
  var sidebarTitle = document.getElementById("sidebar-title");
  var sidebarSplitter = document.getElementById("sidebar-splitter");
  //var others-button = document.getElementById('potosidebar-others-button');

  POTO_RemLastOpen();

  if (!forceOpen && elt.getAttribute("checked") == "true") {
    elt.removeAttribute("checked");
    sidebarBox.setAttribute("sidebarcommand", "");
    sidebarTitle.setAttribute("value", "");
    sidebarBox.hidden = true;
    sidebarSplitter.hidden = true;
    _content.focus();
    return;
  }
  
  var elts = document.getElementsByAttribute("group", "sidebar");
  for (var i = 0; i < elts.length; ++i)
    elts[i].removeAttribute("checked");

  elt.setAttribute("checked", "true");;

  if (sidebarBox.hidden) {
    sidebarBox.hidden = false;
    sidebarSplitter.hidden = false;
  }
  
  var url = elt.getAttribute("sidebarurl");
  var title = elt.getAttribute("sidebartitle");
  if (!title)
    title = elt.getAttribute("label");
  sidebar.setAttribute("src", url);
  sidebarBox.setAttribute("src", url);
  sidebarBox.setAttribute("sidebarcommand", elt.id);
  sidebarTitle.setAttribute("value", title);
  if (aCommandID != "viewWebPanelsSidebar") { // no searchbox there
    // if the sidebar we want is already constructed, focus the searchbox
    if ((aCommandID == "viewBookmarksSidebar" && sidebar.contentDocument.getElementById("bookmarksPanel"))
    || (aCommandID == "viewHistorySidebar" && sidebar.contentDocument.getElementById("history-panel")))
      sidebar.contentDocument.getElementById("search-box").focus();
    // otherwiese, attach an onload handler
    else
      sidebar.addEventListener("load", asyncFocusSearchBox, true);
  }
  
  //others-button.setAttribute('open', false);
}

function POTO_EnumSidebars(aPopup) {
  var popup = document.getElementById('viewSidebarMenu');
  var item, command, broadcaster;

  if (aPopup.hasChildNodes()) {
    //alert(aPopup.childNodes.length + ' childs');
    for (i = aPopup.childNodes.length; i > 0; i--) {
      if (aPopup.firstChild.getAttribute('potosidebar-generated')) {
        //alert('removed:' + i);
        aPopup.removeChild(aPopup.childNodes[0]);
      }
    }
    /*while (aPopup.firstChild.getAttribute('potosidebar-generated')) {
    alert('removed 1');
      aPopup.removeChild(aPopup.firstChild);
    }*/
  }

  /*for (i = 0; i < aPopup.childNodes.length; i++) {
    if (aPopup.childNodes[i].id == 'potosidebar-sep1') {
      sep = aPopup.childNodes[i];
    }
  }*/

  for (i = 2; i < popup.childNodes.length; i++) {
    //if ((popup.childNodes[i].label != "&bookmarks.label;") && (popup.childNodes[i].label != "&history.label;")) {
      item = popup.childNodes[i].cloneNode(true);
      //command = item.getAttribute('oncommand');
      broadcaster = document.getElementById(item.getAttribute('observes'));
      command = broadcaster.getAttribute('oncommand');
      if (!broadcaster.getAttribute('potosidebar-cmdchanged')) {
        broadcaster.setAttribute('oncommand', POTO_Left(command, command.length - 2) + ', true);');
        broadcaster.setAttribute('potosidebar-cmdchanged', true);
      }
      //alert(len(command));
      //item.setAttribute('observes', '');
      //alert(broadcaster.getAttribute('oncommand'));
      //alert(item.getAttribute('observes'));
      item.setAttribute('potosidebar-generated', true);
      //item.setAttribute('onclick', 'POTO_RemLastOpen();');
      //aPopup.insertBefore(item, sep);
      aPopup.appendChild(item);
    //}
  }
}
